﻿using System;
using System.IO;
using Newtonsoft.Json;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.Title = "JsonConverter 클래스 : MemoryStream 직렬화/역직렬화하기";

            string source = "Test string";

            Console.WriteLine("소스 문자열 : {0}", source);

            string json = GetJSON(source);

            Console.WriteLine("JSON 문자열 : {0}", json);
            
            string target = GetString(json);
            
            Console.WriteLine("타겟 문자열 : {0}", target);
            
            Console.Read();
        }

        #endregion

        #region JSON 구하기 - GetJSON(source)

        /// <summary>
        /// JSON 구하기
        /// </summary>
        /// <param name="source">소스 문자열</param>
        /// <returns>JSON 문자열</returns>
        public static string GetJSON(string source)
        {
            MemoryStream memoryStream = new MemoryStream();
            
            StreamWriter streamWriter = new StreamWriter(memoryStream);
            
            streamWriter.WriteLine(source);
            
            streamWriter.Flush();
            
            memoryStream.Position = 0;
            
            string json = JsonConvert.SerializeObject(memoryStream, Formatting.None, new MemoryStreamJSONConverter());

            return json;
        }

        #endregion
        #region 문자열 구하기 - GetString(json)

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <param name="json">JSON 문자열</param>
        /// <returns>문자열</returns>
        public static string GetString(string json)
        {
            MemoryStream memoryStream = JsonConvert.DeserializeObject<MemoryStream>(json, new MemoryStreamJSONConverter());
            
            StreamReader streamReader = new StreamReader(memoryStream);
            
            string target = streamReader.ReadLine();

            return target;
        }

        #endregion
    }
}